function R=gray2rgb_DWT(img1,img2)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%This Program converts a gray image ro RGB image based on the colors of the destination image. The better the destination image match with the source   %
%gray image, the better the coloring will be. The program takes some time  as the searching time is high. You can decrease the searching time by taking %
%only samples from the used color image but quality may decrease. U can use jittered sampling for improving running speed.                              %
%                                                                                                                                                       %
%  You can use also use the attahed test images, Use the following combinations for better result nature1.jpg(as img1) and nature2.jpg(as img2)  or     % 
%  test1.jpg(as img1) and test2.jpg (as img2)
%                                                                                                                                                       %
%                                                                                                                                                       %
% Usage                                                                                                                                                 %
% gray2rgb('nature1.jpg','nature2.jpg');  
% 
%                                                                                                                                                       %
%               Authors : Jeny Rajan                                                                                                                    %
%                         Chandrashekar P.S                                                                                                             %                                     
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                    

% img1 - Source Image  (gray image)                                                                                                        
% img2 - Selected color image for coloring the gray image. 
J=1;
alpha1 = 1;
alpha2 = 1;
lsi53 = {'p', [-0.5 -0.5], [1], [0];'u', [0.25 0.25], [0], [0]; [alpha1], [alpha2], [], []};

tic
clc;
warning off;
imt=imread(img1);
ims=imread(img2);
[sx sy sz]=size(imt);
[tx ty tz]=size(ims);
if sz~=1
    imt=rgb2gray(imt);
end
if tz~=3
    disp ('img2 must be a color image (not indexed)');
else
    imt(:,:,2)=imt(:,:,1);
    imt(:,:,3)=imt(:,:,1);
    
    for i=1:1:3
      coeffs{i} = Lifting2D(double(ims(:,:,i)), J, lsi53);
      coefft{i} = Lifting2D(double(imt(:,:,i)), J, lsi53);
      cims(:,:,i) = dwtcell2arr(coeffs{i}, J);
      cimt(:,:,i) = dwtcell2arr(coefft{i}, J);
    end
    
% Converting to ycbcr color space
    nspace1=rgb2ycbcr(uint8(cims));
    nspace2=rgb2ycbcr(uint8(cimt));
    
   for i=1:1:3
    coeffs{i}=dwtarr2cell(nspace1(:,:,i),J);
    coefft{i}=dwtarr2cell(nspace2(:,:,i),J);
   end
    
%     nspace1=rgb2ycbcr(ims);
%     nspace2=rgb2ycbcr(imt);
% nspace1=ims;
% nspace2=imt;
    
%     figure;
%     imshow(uint8(nspace1));
    
%     for i=1:1:3
%       coeffs{i} = Lifting2D(double(nspace1(:,:,i)), J, lsi53);
%       coefft{i} = Lifting2D(double(nspace2(:,:,i)), J, lsi53);
%     end
%     coeff53 = dwtcell2arr(coefft{1}, J);
    
%     figure;
%     imshow(uint8(coeff53));
    
    for k=1:1:J
        for b=1:1:3
    ms=double(coeffs{1}{k}{b});
    mt=double(coefft{1}{k}{b});
    m1=max(max(ms));
    m2=min(min(ms));
    m3=max(max(mt));
    m4=min(min(mt));
    d1=m1-m2;
    d2=m3-m4;
% Normalization
    dx1=ms;
    dx2=mt;
    dx1=(dx1*255)/(255-d1);
    dx2=(dx2*255)/(255-d2);
    [mx,my,mz]=size(dx2);
%Luminance Comparison
    disp('Please wait..................');
    for i=1:mx
        for j=1:my
             iy=dx2(i,j);
             tmp=abs(dx1-iy);
             ck=min(min(tmp));
             [r,c] = find(tmp==ck);
             ck=isempty(r);
             if (ck~=1)            
                 coeff{2}{k}{b}(i,j)=coeffs{2}{k}{b}(r(1),c(1));
                 coeff{3}{k}{b}(i,j)=coeffs{3}{k}{b}(r(1),c(1));
                 coeff{1}{k}{b}(i,j)=coefft{1}{k}{b}(i,j);           
             end
         end
    end
    
        end 
    end
    
%     LL J+1
    ms=double(coeffs{1}{J+1});
    mt=double(coefft{1}{J+1});
    m1=max(max(ms));
    m2=min(min(ms));
    m3=max(max(mt));
    m4=min(min(mt));
    d1=m1-m2;
    d2=m3-m4;
% Normalization
    dx1=ms;
    dx2=mt;
    dx1=(dx1*255)/(255-d1);
    dx2=(dx2*255)/(255-d2);
    [mx,my,mz]=size(dx2);
%Luminance Comparison
    disp('Please wait..................');
    for i=1:mx
        for j=1:my
             iy=dx2(i,j);
             tmp=abs(dx1-iy);
             ck=min(min(tmp));
             [r,c] = find(tmp==ck);
             ck=isempty(r);
             if (ck~=1)            
                 coeff{2}{J+1}(i,j)=coeffs{2}{J+1}(r(1),c(1));
                 coeff{3}{J+1}(i,j)=coeffs{3}{J+1}(r(1),c(1));
                 coeff{1}{J+1}(i,j)=coefft{1}{J+1}(i,j);           
             end
         end
    end
    
%     for i=1:1:3
%       nimage(:,:,i) = iLifting2D(coeff{i}, J, lsi53);
%     end
%    
%     unimage=uint8(nimage);
% %     figure;
% %     imshow(uint8(nimage));
%     
%     rslt=ycbcr2rgb(unimage);
% %     rslt=unimage;
%     RR=uint8(rslt);
   for i=1:1:3
      cim(:,:,i) = dwtcell2arr(coeff{i}, J);
   end
   nimage=double(ycbcr2rgb(uint8(cim)));
   for i=1:1:3
   coecell{i}=dwtarr2cell(nimage(:,:,i),J);
   end
   
   for i=1:1:3
      rslt(:,:,i) = iLifting2D(coecell{i}, J, lsi53);
   end
   
%     save ('gray2rgb_DWT.mat');
    figure,imshow(uint8(imt));
    figure,imshow(uint8(rslt));
%     figure,imshow(rslt);
   
    toc
end